/* mode7b.S:
 * This file is used to create the actual mode7.S file.   The '2464'
 * field below is replaced (automatically) with the actual size of
 * the binary image (mode7.bin) created.
 *
 * This code can be pumped onto a BF537 through UART-A when in boot
 * mode 7.
 *
 * The 'header' tag below is the 10-byte header discussed in chapter 19
 * of the BF537 HW reference manual.  The first entry is the destination
 * address of the load and the second entry is the size of the image.
 * Note that this is a subtraction (i.e. N-10).  The value of 'N' is the
 * size of the mode7.bin file, after running 'make mode7' if these two
 * values don't match, change the number in this file to match the size
 * of the .bin file, then run "make mode7" one more time.
 * This will create an image that can be downloaded into the STAMP using
 * Mode 7 boot (see reference manual for more details).
 */
	.extern _MonStack
	.extern _mode7start
	.global _coldstart

_header:
	.long	0xffa00000		/* Base address of L1 Instruction space.	*/
	.long	2464-10		/* Size of image not including the header.	*/
	.short	0x8002			/* Boot flag word.							*/

_coldstart:
	r1.l = _MonStack+120
	r1.h = _MonStack+120
	sp = r1
	JUMP.L _mode7start
