#include "config.h"
#include "stddefs.h"
#include "cpuio.h"
#include "genlib.h"
#include "cache.h"
#include "warmstart.h"
#include "cpu.h"

/* devInit():
 */
void
devInit(int baud)
{
}

/* target_console_empty():
 * Returns 1 if there are no characters waiting to
 * be put out on the UART; else return 0 indicating that the UART
 * is still busy outputting characters from its FIFO.
 */
int
target_console_empty(void)
{
	return(1);
}

/* target_putchar():
 * When buffer has space available, load the incoming character
 * into the UART.
 */
int
target_putchar(char c)
{
    return(putchar(c));
}

/* target_gotachar():
 * Return 0 if no char is avaialable at UART rcv fifo; else 1.
 * Do NOT pull character out of fifo, just return status. 
 */
int
target_gotachar(void)
{
    return(0);
}

/* target_getchar():
 * Assume there is a character in the UART's input buffer and just
 * pull it out and return it.
 */
int 
target_getchar(void)
{
    return((int)getchar());
}

void
cacheInitForTarget(void)
{
}

void
target_reset(void)
{
}

/* If any CPU IO wasn't initialized in reset.S, do it here...
 * This just provides a "C-level" IO init opportunity. 
 */
void
initCPUio(void)
{
	/* ADD_CODE_HERE */
}

unsigned long
intsoff(void)
{
	return(0);
}

void
intsrestore(unsigned long val)
{
}

void
warmstart(int val)
{
	extern void start(int);
	start(val);
}

void
reginit(void)
{
}

void
vinit(void)
{
}

char *
ExceptionType2String(int type)
{
	return("N/A");
}


int ExceptionType;
unsigned long ExceptionAddr;

extern int moncom(int cmd, void *arg1, void *arg2, void *arg3);
int	(*moncomptr)(int,void *, void *, void *) = moncom;

int
ConsoleBaudSet(int baud)
{
	return(baud);
}

int
main()
{
	extern void start(int);
	start(INITIALIZE);
}
